unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, StrUtils, ImgList, Buttons, Grids;


type
  TStartCount = record
    Start: integer;
    Count: integer;
  end;

  TForm1 = class(TForm)
    TreeView1: TTreeView;
    OpenDialog1: TOpenDialog;
    Panel2: TPanel;
    Memo1: TMemo;
    Edit1: TEdit;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Memo2: TMemo;
    ImageList1: TImageList;
    Button4: TButton;
    SpeedButton1: TSpeedButton;
    Button5: TButton;
    Label1: TLabel;
    Panel1: TPanel;
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure TreeView1Change(Sender: TObject; Node: TTreeNode);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure TreeView1Changing(Sender: TObject; Node: TTreeNode;
      var AllowChange: Boolean);
    procedure Button5Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private 錾 }
    MemoIndex: integer;
    TempList: TList;
    procedure ListClear;
    procedure SearchImplementation;
    procedure SearchPrFn;
    function SearchEnd: Boolean;
    procedure SearchComment;
    procedure RemendStart(Node: TTreeNode; Count: integer);
    procedure ClearTreeViewData;
    procedure Execute;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button3Click(Sender: TObject);
begin
        Close;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
        ClearTreeViewData;
        ListClear;
        Memo2.Lines.LoadFromFile(OpenDialog1.FileName);
        MemoIndex:=0;
        SearchImplementation;
    while MemoIndex < Memo2.Lines.Count do
    begin
        Execute;
    end;
    if TempList.Count > 0 then
    begin
        ListClear;
    end;
  end;
end;

procedure TForm1.TreeView1Change(Sender: TObject; Node: TTreeNode);
var
  i: integer;
  s: ^TStartCount;
begin
        s:=Node.Data;
  if Node.Level = 1 then
  begin
        Memo1.Clear;
    for i:=s^.Start to s^.Start+s^.Count-1 do
    begin
        Memo1.Lines.Add(Memo2.Lines[i]);
    end;
        Memo1.Modified:=false;
  end;
        i:=SendMessage(Memo2.Handle,EM_GETFIRSTVISIBLELINE,0,0);
        SendMessage(Memo2.Handle,EM_LINESCROLL,0,s^.Start-i);
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  i: integer;
  s: ^TStartCount;
  t: string;
begin
  if (TreeView1.SelectionCount > 0)and(TreeView1.Selected.Level = 1)and
    (Memo1.Modified = true) then
  begin
        s:=TreeView1.Selected.Data;
    for i:=1 to s^.Count do
    begin
        Memo2.Lines.Delete(s^.Start);
    end;
    for i:=Memo1.Lines.Count-1 downto 0 do
    begin
      if Copy(TrimLeft(Memo1.Lines[i]),1,2) = '//' then
      begin
                Memo2.Lines.Insert(s^.Start,Memo1.Lines[i]);
      end else
      begin
                t:=Memo1.Lines[i];
        if Copy(t,1,2) = '  ' then
        begin
                Delete(t,1,2);
        end;
                Memo2.Lines.Insert(s^.Start,'//'+t);
      end;
    end;
    if Memo1.Lines.Count-s^.Count <> 0 then
    begin
        RemendStart(TreeView1.Selected,Memo1.Lines.Count-s^.Count);
    end;
        Memo1.Modified:=false;
        s^.Count:=Memo1.Lines.Count;
        TreeView1.Selected.StateIndex:=4;
        TreeView1Change(Sender,TreeView1.Selected);
  end;
end;

procedure TForm1.Button4Click(Sender: TObject);
var
  s: TTreeNode;
  p: ^TStartCount;
begin
  if (TreeView1.SelectionCount > 0)and(TreeView1.Selected.Level = 0) then
  begin
        s:=TreeView1.Selected;
        New(p);
        p^.Start:=TStartCount(s.Data^).Start;
        p^.Count:=0;
        TreeView1.Items.AddChildObject(s,IntToStr(s.Count+1),p).StateIndex:=1;
        s.Expanded:=true;
  end;
end;

procedure TForm1.TreeView1Changing(Sender: TObject; Node: TTreeNode;
  var AllowChange: Boolean);
begin
  if Memo1.Modified = true then
  begin
    case MessageDlg('ύXۑ܂',mtConfirmation,[mbYes,mbNo,mbCancel],0) of
    mrYes:
        Button2Click(Sender);
    mrCancel:
        AllowChange:=false;
    end;
  end;
        Memo1.Clear;
end;

procedure TForm1.Button5Click(Sender: TObject);
var
  i, j: integer;
begin
  if FileExists(OpenDialog1.FileName) = true then
  begin
        Memo2.Lines.SaveToFile(OpenDialog1.FileName);
    for i:=0 to TreeView1.Items.Count-1 do
    begin
      for j:=0 to TreeView1.Items[i].Count-1 do
      begin
                TreeView1.Items[i].Item[j].StateIndex:=1;
      end;
    end;
  end else
  begin
        Showmessage('t@C܂');
  end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
        ClearTreeViewData;
        TempList.Clear;
        TempList.Free;
end;

procedure TForm1.ClearTreeViewData;
var
  i, j: integer;
  s: TTreeNode;
  t: ^TStartCount;
begin
  for i:=0 to TreeView1.Items.Count-1 do
  begin
        s:=TreeView1.Items[i];
        t:=s.Data;
        Dispose(t);
  end;
        TreeView1.Items.Clear;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
var
  i: integer;
  p: ^TStartCount;
begin
  if (Edit1.Text <> '')and(TreeView1.Selected.Level = 1) then
  begin
        p:=TreeView1.Selected.Data;
    for i:=1 to p^.Count do
    begin
        Memo2.Lines.Delete(p^.Start);
    end;
        Memo2.Lines.Insert(p^.Start,'//~~~~~~~~~~~~~~~~~~~~~~~~~~//');
        Memo2.Lines.Insert(p^.Start,'//////////////////////////////');
        Memo2.Lines.Insert(p^.Start,'//');
        Memo2.Lines.Insert(p^.Start,'//   '+Edit1.Text);
        Memo2.Lines.Insert(p^.Start,'//');
        Memo2.Lines.Insert(p^.Start,'//////////////////////////////');
      if 6-p^.Count <> 0 then
      begin
                RemendStart(TreeView1.Selected,6-p^.Count);
      end;
        p^.Count:=6;
        TreeView1.Selected.StateIndex:=4;
        TreeView1Change(Sender,TreeView1.Selected);
  end;
end;

procedure TForm1.RemendStart(Node: TTreeNode; Count: integer);
var
  i: integer;
  x: Boolean;
  s: ^TStartCount;
begin
        x:=false;
  for i:=0 to TreeView1.Items.Count-1 do
  begin
    if x = true then
    begin
        s:=TreeView1.Items[i].Data;
        s^.Start:=s^.Start+Count;
    end else
        if TreeView1.Items[i] = Node then
    begin
        x:=true;
    end;
  end;
end;

function TForm1.SearchEnd: Boolean;
var
  i: integer;
  s: string;
begin
        result:=false;
        s:=Memo2.Lines[MemoIndex];
  for i:=1 to Length(s)-2 do
  begin
    case s[i] of
    'e','E':
      if CompareText(Copy(s,i,3),'end') = 0 then
      begin
                result:=true;
                break;
      end;
    end;
  end;
end;

procedure TForm1.SearchImplementation;
var
  i: integer;
begin
  for i:=0 to Memo2.Lines.Count-1 do
  begin
    if AnsiStartsText('implementation',TrimLeft(Memo2.Lines[i])) = true then
    begin
        MemoIndex:=i+1;
        break;
    end;
  end;
end;

procedure TForm1.SearchPrFn;
var
  s: string;
  n: TTreeNode;
  procedure Main;
  var
    i, j: integer;
    p: ^TStartCount;
  begin
        New(p);
        p^.Start:=MemoIndex;
        p^.Count:=0;
        j:=0;
        s:='';
    while MemoIndex < Memo2.Lines.Count do
    begin
        s:=s+TrimLeft(Memo2.Lines[MemoIndex]);
      for i:=j to Length(s)-1 do
      begin
        if IsDelimiter('(;',s,i) = true then
        begin
                n:=TreeView1.Items.AddObject(nil,TrimLeft(Copy(s,10,i-10)),p);
          for j:=0 to TempList.Count-1 do
          begin
                TreeView1.Items.AddChildObject(n,IntToStr(j+1),TempList[j]);
          end;
                TempList.Clear;
                inc(MemoIndex);
                Exit;
        end;
      end;
        j:=Length(s);
        inc(MemoIndex);
    end;
  end;
begin
        s:=TrimLeft(Memo2.Lines[MemoIndex]);
    if AnsiStartsText('procedure ',s) = true then
    begin
        Main;
        n.StateIndex:=2;
    end else
        if ANsiStartsText('function ',s) = true then
    begin
        Main;
        n.StateIndex:=3;
    end;
end;

procedure TForm1.Execute;
begin
        SearchPrFn;
        SearchComment;
  if (TempList.Count > 0)and(SearchEnd = true) then
  begin
        ListClear;
  end;
end;

procedure TForm1.SearchComment;
var
  s: ^TStartCount;
begin
  if Copy(TrimLeft(Memo2.Lines[MemoIndex]),1,2) = '//' then
  begin
        New(s);
        s^.Start:=MemoIndex;
    repeat
        inc(MemoIndex);
    until Copy(TrimLeft(Memo2.Lines[MemoIndex]),1,2) <> '//';
        TempList.Add(s);
        s^.Count:=MemoIndex-s^.Start;
  end else
  begin
        inc(MemoIndex);
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
        TempList:=TList.Create;
end;

procedure TForm1.ListClear;
var
  i: integer;
begin
  for i:=0 to TempList.Count-1 do
  begin
        Dispose(TempList[i]);//Memory Block : TStartCount = record
  end;
        TempList.Clear;
end;

end.
